# LizardLib Beta 1c

## What and Why?

Since the release of TF2 VScript I've accumulated a bunch of useful general-purpose stuff, and I believe it will be useful not just for me, but for anyone making a VScript-powered project.

### VSCode integration:
Put `lizardlib.code-snippets` file into `.vscode` folder of your project.

## Key features

1. Normally, you can attach only 1 function per game event via `OnGameEvent_x`. I've made a system to attach as many game event listeners as you want and define their execution order.<p>
The event listeners share their lifetime with the scope they're created in, allowing you to discard listeners by simply discarding the scope.<p>
If an event listener throws an exception, it will be contained inside that listener.<p>
In addition, you can create and pass custom events around the script.<p>
See `listeners.nut`.

2. Normally, you can create only 1 `think` function per script, therefore all your repeating activities share the same timer.
With this library you can create as many independent timers as you want.<p>
Similar to event listeners, you can set the priority order, timers get deleted with their associated scope, and exceptions don't leak outside of the timer function.<p>
Please note that the timer precision is limited by TF2 ticks (1\66th of a second) and won't execute more than once per tick.<p>
See `timers.nut`.

3. Another system allows you to schedule delayed execution of a function. Similar to the previous systems, a scheduled function will not be executed if its scope gets discarded.<p>
See `timers.nut`.

4. This library folds Constants and NetProps, so that you could write `GetPropInt(...)` instead of `NetProps.GetPropInt(...)` or `TF_CLASS_HEAVYWEAPONS` instead of `Constants.ETFClass.TF_CLASS_HEAVYWEAPONS`.

5. Various utility functions.

6. Normally, the outputs needed to set VScript parameters from within the map I/O aren't intuitive for the mappers. I've created a system that is more straightforward. Create a `info_particle_system`, and use Control Point fields to specify the key and the value of the parameters (see `api_config.nut`):

![](https://i.imgur.com/rcmF3y7.png)

## Is there a manual?
I'm running short on time. So I figured, releasing a library without a proper manual is better than sitting on it unreleased.<p>
Also, please let me know of a good system to host a manual, as I couldn't find any. A simple readme.md (which is what you're reading right now) doesn't have sufficient formatting capabilities.

## Credits

Made by: LizardOfOz

Additional Credits: Ficool2, Mr.Burguers